package com.ruoyi.jjh.declaration.controller;

/**
 * @author dong
 * @since 2024/5/22 15:50
 */

import cn.hutool.http.HttpUtil;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.ruoyi.common.core.domain.AjaxResult;

import com.ruoyi.jjh.declaration.util.AESEncryptor;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * 单点登陆
 */
@Api(tags = "单点登陆")
@RestController
@RequestMapping("/system/singlelogin")
public class SingleLoginController {

    @Value("${url}")
    private String url;

    @Value("${tokenUrl}")
    private String tokenUrl;

    @Value("${infoUrl}")
    private String infoUrl;

    /**
     * 统一登陆
     *
     * @return
     */
    @ApiOperation("统一登陆")
    @GetMapping("/login")
    public void login(HttpServletResponse response) throws IOException {
        String appMark = "jjhxdfw";
        String returnUrl ="http://192.168.0.113:9040/system/singlelogin/getToken";
        String gotoUrl="https://www.baidu.com";
        String responseUrl = url+"?appMark="+appMark+"&returnUrl="+returnUrl+"&gotoUrl="+gotoUrl;
        response.sendRedirect(responseUrl);
    }


    /**
     * 获取令牌（token）
     *
     * @return
     */
    @ApiOperation("获取令牌")
    @GetMapping("/getToken")
    public AjaxResult getToken() throws Exception {
        String APPMARK = "jjhxdfw";
        String APPWORD = "vvoTza3RZh23hXiG";
        String timeStamp = String.valueOf(System.currentTimeMillis());
        // 获取sign
        String sign = APPMARK + APPWORD + timeStamp;
        sign = AESEncryptor.encrypt(sign);
        ObjectMapper objectMapper = new ObjectMapper();
        // 创建 ObjectNode 对象
        ObjectNode jsonNode = objectMapper.createObjectNode();
        // 设置 JSON 对象的各个属性
        jsonNode.put("appmark", APPMARK);
        jsonNode.put("time", timeStamp);
        jsonNode.put("sign", sign);
        jsonNode.put("servicename", "ticketValidate");
        // 创建 params 属性的 JSON 对象
        ObjectNode paramsNode = objectMapper.createObjectNode();
        paramsNode.put("ticket", "");
        jsonNode.set("params", paramsNode);
        String jsonString = jsonNode.toString();
        String response = HttpUtil.createPost(infoUrl)
                .body(jsonString, "application/json")
                .execute()
                .body();

        return AjaxResult.success(response);
    }


    /**
     * 获取用户信息
     *
     * @return
     */
    @ApiOperation("获取用户信息")
    @GetMapping("/getInfo")
    public AjaxResult getInfo(@RequestParam("token") String token) throws Exception {
        String APPMARK = "jjhxdfw";
        String APPWORD = "";
        String timeStamp = String.valueOf(System.currentTimeMillis());
        // 获取sign
        String sign = APPMARK + APPWORD + timeStamp;
        sign = AESEncryptor.encrypt(sign);
        ObjectMapper objectMapper = new ObjectMapper();
        // 创建 ObjectNode 对象
        ObjectNode jsonNode = objectMapper.createObjectNode();
        // 设置 JSON 对象的各个属性
        jsonNode.put("appmark", APPMARK);
        jsonNode.put("time", timeStamp);
        jsonNode.put("sign", sign);
        jsonNode.put("servicename", "findOutsideUserByToken");
        // 创建 params 属性的 JSON 对象
        ObjectNode paramsNode = objectMapper.createObjectNode();
        paramsNode.put("token", token);
        jsonNode.set("params", paramsNode);
        // 将 JSON 对象转换为字符串
        String jsonString = jsonNode.toString();
        String response = HttpUtil.createPost(infoUrl)
                .body(jsonString, "application/json")
                .execute()
                .body();
        return AjaxResult.success(response);
    }

}
